from linkedlist import LinkedList


class LinkedStack:

    def __init__(self):
        self.__stack = LinkedList()

    def size(self):
        return self.__stack.size()

    def is_empty(self):
        return self.__stack.is_empty()

    def top(self):
        return self.__stack.first()

    def push(self, e):
        self.__stack.add_first(e)

    def pop(self):
        return self.__stack.remove_first()

    def __str__(self):
        return self.__stack.__str__()

    def __iter__(self):
        return self.__stack.__iter__()


class ListStack:

    def __init__(self):
        self.__stack = list()

    def size(self):
        return len(self.__stack)

    def is_empty(self):
        return self.size() == 0

    def top(self):
        if self.is_empty():
            return None
        return self.__stack[-1]

    def push(self, e):
        # append e to the list
        self.__stack.append(e)

    def pop(self):
        if self.is_empty():
            return None
        # remove the last element
        return self.__stack.pop()

    def __str__(self):
        return str(self.__stack)

    def __iter__(self):
        self.__stack.reverse()
        for elem in self.__stack:
            yield elem


if __name__ == '__main__':
    linked_stack = LinkedStack()
    print(linked_stack.size())
    print(linked_stack.is_empty())
    for n in range(5):
        linked_stack.push(n)
        print('top element', linked_stack.top())
        print(linked_stack)
    for elem in linked_stack:
        print(elem)
    for times in range(6):
        print(linked_stack.pop())
        print(linked_stack)
    list_stack = ListStack()
    print(list_stack.size())
    print(list_stack.is_empty())
    print(list_stack.top())
    print(list_stack.pop())
    for n in range(5):
        list_stack.push(n)
        print('top element', list_stack.top())
        print(list_stack)
    for elem in list_stack:
        print(elem)
    for times in range(6):
        print(list_stack.pop())
        print(list_stack)

