from linkedlist import LinkedList
from doubly_linkedlist import DoublyLinkedList
from stacks import LinkedStack, ListStack
from queues import LinkedQueue, ListQueue

def diff(stack1: LinkedStack, stack2: LinkedStack) -> LinkedStack:
    new_stack = LinkedStack()
    elements = []
    #extract all the first stack element
    try:
        my_iter = iter(stack1)
        while(True):
            temp = next(my_iter)
            if temp not in elements:
                elements.append(temp)
        
    except Exception:
        pass
    #extract all the second stack element
    try:
        my_iter = iter(stack2)
        while(True):
            temp = next(my_iter)
            if temp not in elements:
                elements.append(temp)
        
    except Exception:
        pass
    elements = sorted(elements,reverse = True)#$sort the elements in the reverse order
    for i in elements:
        new_stack.push(i)#add all the elements to the list
        
    return new_stack #return new list 


def remove_max(stack: ListStack) -> ListStack:
    new_stack = LinkedStack()
    #find the max elemets
    try:
        my_iter = iter(stack)
        elemets = []
        max_element = -9999999
        while(True):
            temp = next(my_iter)
            elemets.append(temp)
            if temp > max_element:
                max_element = temp
    except Exception:
        pass
    elemets.remove(max_element)
    for i in range(len(elemets)-1,-1,-1):
        new_stack.push(elemets[i])#add all the elements to the list
    
    return new_stack

def copy_queue(queue: LinkedQueue) -> ListQueue:
    list_queue = ListQueue()
    try:
        my_iter = iter(queue)
        while(True):
            temp = next(my_iter)    
            list_queue.enqueue(temp)
    except Exception:
        pass
    
    return list_queue

def swap(stack: ListQueue) -> ListQueue:
    list_queue = ListQueue()
    last_element = 0
    first_element = 0
    counter = 0
    #extract the last element
    try:
        my_iter = iter(stack)
        first_element = next(my_iter)
        while(True):
            last_element = next(my_iter)    
            counter += 1
    except Exception:
        pass
    
    list_queue.enqueue(last_element)
    try:
        my_iter = iter(stack)
        temp = next(my_iter)
        while(True):
            temp = next(my_iter)
            if counter > 1:
                list_queue.enqueue(temp)
            counter -= 1
    except Exception:
        pass
    list_queue.enqueue(first_element)
    return list_queue


def compare(queue1: LinkedQueue, queue2:LinkedQueue) -> bool:
    try:
        my_iter = iter(queue1)
        while(True):
            flag = False
            temp = next(my_iter)
            try:
                 my_iter_2 = iter(queue2)
                 while(True):
                     temp_2 = next(my_iter_2)
                     if temp == temp_2:
                         flag = True
                         break
                
            except Exception:
                pass
            if flag == False:
                return False
    except Exception:
        pass
    return True

def merge(q1: ListQueue, q2: ListQueue) -> ListQueue:
    all_elements = []
    new_queue = ListQueue()
    try:
        my_iter = iter(q1)
        while(True):
            all_elements.append(int(next(my_iter)))
    except Exception:
        pass
    
    try:
        my_iter = iter(q2)
        while(True):
            all_elements.append(int(next(my_iter)))
    except Exception:
        pass
    all_elements = sorted(all_elements)
    for i in all_elements:
        new_queue.enqueue(i)
    return new_queue

if __name__ == "__main__":
    #Test cases of first function
    print("Test Case of diff function")
    linked_stack_1 = LinkedStack()
    linked_stack_1.push(5)
    linked_stack_1.push(4)
    linked_stack_1.push(3)
    linked_stack_1.push(2)
    linked_stack_1.push(1)
     
    linked_stack_2 = LinkedStack()
    linked_stack_2.push(7)
    linked_stack_2.push(6)
    linked_stack_2.push(5)
    linked_stack_2.push(4)
    linked_stack_2.push(3)
    print("Stack 1: " ,linked_stack_1)
    print("Stack 1: " ,linked_stack_2)
    print("Diff: ",diff(linked_stack_1,linked_stack_2))
    print()
    
    print("Test case of remove_max function")    
    linked_stack_3 = LinkedStack()
    linked_stack_3.push(6)
    linked_stack_3.push(5)
    linked_stack_3.push(4)
    linked_stack_3.push(7)
    linked_stack_3.push(8)
    linked_stack_3.push(9)
    linked_stack_3.push(1)
    linked_stack_3.push(2)    
    print("Stack 1: ",linked_stack_3)
    print("After Remove Max: ",remove_max(linked_stack_3))
    print()
    
    
    
    print("Test Case of copy_queue Function")
    linked_queue = LinkedQueue()
    linked_queue.enqueue('A')
    linked_queue.enqueue('B')
    linked_queue.enqueue('C')
    linked_queue.enqueue('D')
    linked_queue.enqueue('E')
    linked_queue.enqueue('F')
    linked_queue.enqueue('G')
    linked_queue.enqueue('H')
    print("Linked Queue1 : ",linked_queue)
    print("After Copy: " , copy_queue(linked_queue))
    print()
    
    print("Test case of swap")
    list_queue = ListQueue()
    list_queue.enqueue('A')
    list_queue.enqueue('B')
    list_queue.enqueue('C')
    list_queue.enqueue('D')
    list_queue.enqueue('E')
    list_queue.enqueue('F')    
    print("List Queue: ",list_queue)
    print("After Swap: ",swap(list_queue))
    print()
    
    print("Test case for compare")
    linked_queue_2 = LinkedQueue()
    linked_queue_2.enqueue('1')
    linked_queue_2.enqueue('2')
    linked_queue_2.enqueue('3')
    linked_queue_2.enqueue('4')
    linked_queue_2.enqueue('5')
    linked_queue_3 = LinkedQueue()
    linked_queue_3.enqueue('3')
    linked_queue_3.enqueue('4')
    linked_queue_3.enqueue('5')
    linked_queue_3.enqueue('1')
    linked_queue_3.enqueue('2')
    print("Linked queue 1: ",linked_queue_2)
    print("Linked queue 2: ",linked_queue_3)
    print("After compare: ", compare(linked_queue_2,linked_queue_3))
    print()
    
    print("Test case of merge")
    list_queue_2 = ListQueue()
    list_queue_2.enqueue(2)
    list_queue_2.enqueue(11)
    list_queue_2.enqueue(19)
    list_queue_2.enqueue(21)
    list_queue_2.enqueue(23)
    list_queue_2.enqueue(24)   
    list_queue_3 = ListQueue()
    list_queue_3.enqueue(3)
    list_queue_3.enqueue(9)
    list_queue_3.enqueue(15)
    list_queue_3.enqueue(16)
    list_queue_3.enqueue(22)
    
    print("Q1 : ",list_queue_2)
    print("Q2 : ",list_queue_3)
    print("After Merge: ",merge(list_queue_2,linked_queue_3))
    
    
    
    